// AdminTabDlg.cpp : Implementation of TotalPingDlg
#include "stdafx.h"
#include "SWMessages.h"
#include "DFRegTool.h"
#include "SWPluginServerStruct.h"
#include "CustomData.h"
#include <limits.h>
#include "SWError.h"
#include "CustomData.h"
#include <sstream>

#include "TotalPingDlg.h"

/////////////////////////////////////////////////////////////////////////////
// TotalPingDlg

TotalPingDlg::TotalPingDlg()
{
    m_hwndTotalPings = NULL;
	m_pCurrentServer = NULL;
    m_pLastServer    = NULL;
}

TotalPingDlg::~TotalPingDlg()
{
}

LRESULT TotalPingDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    m_hwndTotalPings = GetDlgItem(IDC_TOTAL_PINGS);
    _ASSERT(m_hwndTotalPings);

	return 1;  // Let the system set the focus
}

LRESULT TotalPingDlg::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 1;
}
      
LRESULT TotalPingDlg::OnSetDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//store for later use
    if( NULL != m_pLastServer )
    {
        ((CustomData*)(m_pLastServer->pCustomData))->Unregister( this, CustomData::PING_TOTAL_CHANGED );
    }

    m_pLastServer = m_pCurrentServer;

	m_pCurrentServer = (SWPluginServerStruct*)wParam;

    CustomData* pMyData = (CustomData*)(m_pCurrentServer->pCustomData);

    pMyData->Register( this, CustomData::PING_TOTAL_CHANGED );

    std::wstringstream string;
    string << pMyData->GetNumberOfPings();
    ::SetWindowText( m_hwndTotalPings, string.str().c_str() );

    return 0;
}

void TotalPingDlg::Notification(Subject* subject, const Aspect& aspect)
{
    CustomData* pMyData = (CustomData*)m_pCurrentServer->pCustomData;

    std::wstringstream string;
    string << pMyData->GetNumberOfPings();
    ::SetWindowText( m_hwndTotalPings, string.str().c_str() );
}
    
LRESULT TotalPingDlg::OnChangesApplied(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    return 0;
}

LRESULT TotalPingDlg::OnChangesReset(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    return 0;
}

LRESULT TotalPingDlg::OnPluginDataReady(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    return 0;
}

LRESULT TotalPingDlg::OnEnableApply(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

LRESULT TotalPingDlg::OnEnableReset(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

LRESULT TotalPingDlg::OnNotifyFormat(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    return NFR_UNICODE;
}

const std::wstring& TotalPingDlg::GetTitle() const
{
    static std::wstring strTitle = L"Total Pings";

    return strTitle;
}

ISWPluginPane::DisplayMode TotalPingDlg::GetDisplayMode() const
{
    return ISWPluginPane::DataOnly;
}

HWND TotalPingDlg::GetPaneHWND() const
{
    return m_hWnd;
}

bool TotalPingDlg::IsResizeable() const
{
    return false;
}

void TotalPingDlg::PrePaneSelection()
{
}