// AdminTabDlg.h : Declaration of the TotalPingDlg

#ifndef __ADMINTABDLG_H_
#define __ADMINTABDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "SWMessages.h"
#include "SWPluginServerStruct.h"
#include "IObserver.h"

// when defining windows messages refer to SWMessages.h
// to ensure message range compatibility

/////////////////////////////////////////////////////////////////////////////
// TotalPingDlg
class TotalPingDlg : 
	public CDialogImpl<TotalPingDlg>,
    public ISWPluginPane,
    public IObserver
{
public:
	TotalPingDlg();
	~TotalPingDlg();

	enum { IDD = IDD_TOTAL_PINGS };

    /**
     * @name ISWPane
     * Implements ISWPane Interface
     */
    //@{
        virtual const std::wstring& GetTitle() const;
        virtual DisplayMode GetDisplayMode() const;
        virtual HWND GetPaneHWND() const;
        virtual bool IsResizeable() const;
        virtual void PrePaneSelection();
    //@}

    /**
     * @name IObserver
     * Implements IObserver Interface
     */
    //@{
	    virtual void Notification(Subject* subject, const Aspect& aspect);
    //@}

BEGIN_MSG_MAP(TotalPingDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(SWP_SET_DIALOG, OnSetDialog)
    MESSAGE_HANDLER(SWP_CHANGES_APPLIED, OnChangesApplied)
    MESSAGE_HANDLER(SWP_CHANGES_RESET, OnChangesReset)
    MESSAGE_HANDLER(SWPN_DATAREADY, OnPluginDataReady)
	MESSAGE_HANDLER(SWPN_ENABLE_APPLY, OnEnableApply)
	MESSAGE_HANDLER(SWPN_ENABLE_RESET, OnEnableReset)
    MESSAGE_HANDLER(WM_NOTIFYFORMAT, OnNotifyFormat)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnNotifyFormat(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSetDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChangesApplied(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChangesReset(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnPluginDataReady(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnEnableApply(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnEnableReset(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

private:
	HWND m_hwndTotalPings;

    SWPluginServerStruct* m_pCurrentServer;
    SWPluginServerStruct* m_pLastServer;
};

#endif //__ADMINTABDLG_H_
