#ifndef _SWCUSTOMDATASTRUCT_H
#define _SWCUSTOMDATASTRUCT_H

#include "NetworkDlg.h"

#define DEFAULT_BUFFERLENGTH _T("600")
#define MINIMUM_BUFFERLENGTHSTR _T("12")
#define MINIMUM_BUFFERLENGTHINT 12

// Custom Data Structure
struct CustomDataStruct
{
    enum POP_SEQUENCE
    {
        UNCONNECTED,
		CONNECT,
        USERNAME,
        PASSWORD,
		STATUS,
		LIST,
		TOP,
		DISCONNECT
    };

    CNetworkDlg* pAdminNetwork;
    CString strPassword;
	CString strUsername;
    bool fRememberPassUser;
    bool fSettingsLoaded;
	POP_SEQUENCE NetworkSequence;
	ISWServerSettings* pSettings;
	ISWServerData* pServerData;
	HANDLE mutex;
    //bool fSendingCommand;
    CustomDataStruct()
    {
        pAdminNetwork = NULL;
        strPassword = _T("");
		strUsername = _T("");
        fRememberPassUser = FALSE;
        fSettingsLoaded = FALSE;
		NetworkSequence = UNCONNECTED;
		pSettings = NULL;
		pServerData = NULL;
		mutex = CreateMutex( NULL, FALSE, NULL );
        //fSendingCommand = FALSE;
    }
	~CustomDataStruct()
	{
		if( pSettings )
			pSettings->Release();
		if( pServerData )
			pServerData->Release();
		CloseHandle( mutex );
	}
};

#endif // _SWCUSTOMDATASTRUCT_H