// NetworkDlg.h : Declaration of the CNetworkDlg

#ifndef __NetworkDlg_H_
#define __NetworkDlg_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "SWPluginServerStruct.h"
#include <SYS\TIMEB.H>

// when defining windows messages refer to SWMessages.h
// to ensure message range compatibility
#define IDM_ASYNC     WM_USER + 100
#define SOCKADDR_LEN sizeof(struct sockaddr)

#define BUFFER_LEN 2000
#define SCENTENCE_LEN 600

#define DEFAULT_TABLE _T("UsersTable")
	
#define EVENT_ARRAY_SIZE 2

/////////////////////////////////////////////////////////////////////////////
// CNetworkDlg
class CNetworkDlg : 
	public CDialogImpl<CNetworkDlg>
{
public:
	void OnNetworkRead();
	CNetworkDlg();
	~CNetworkDlg();

	enum { IDD = IDD_ADMINNETWORKDIALOG };

BEGIN_MSG_MAP(CNetworkDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroyDialog )
    MESSAGE_HANDLER(IDM_ASYNC, OnAsynchronousMessage)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroyDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnAsynchronousMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    SWRESULT Ping();
    int DealWithPacket(char *rawpkt, int pktlen);

private:
    void     CleanupNetwork();
	void     SetError( const CString &strErrMessage );
	SWRESULT NextRecv( char* rawpkt, int iFirstUnprocessedCell, const int iBufferLen );

	SWRESULT OnConnect( char* rawpkt, int pktct );
	SWRESULT OnUserName( char* rawpkt, int pktct );
	SWRESULT OnPassword( char* rawpkt, int pktct );
	SWRESULT OnStatus( char* rawpkt, int pktct );
	SWRESULT OnList( char* rawpkt, int pktct );
	SWRESULT OnTop( char* rawpkt, int pktct );
	SWRESULT OnDisconnect( char* rawpkt, int pktct );

    SOCKET m_sSocket;
    SWPluginServerStruct* m_pThisServer;
    CStringA m_strSendBuffer;
    char szRecvBuffer[BUFFER_LEN];
    HANDLE* m_rghSynchronize;
	bool m_bCheckOK;
	unsigned long m_uiRowNumLastEdited;
	unsigned int m_uiNumMessages;
};

#endif //__NetworkDlg_H_
