// SettingsDlg.h : Declaration of the CSettingsDlg

#ifndef __SETTINGSDLG_H_
#define __SETTINGSDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "SWMessages.h"
#include "SWPluginServerStruct.h"
#include "ISWPluginPane.h"

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg
class CSettingsDlg : 
	public CDialogImpl<CSettingsDlg>,
    public ISWPluginPane
{
public:
	CSettingsDlg();
	~CSettingsDlg();

	enum { IDD = IDD_SETTINGSDLG };

    /** @name Implements ISWPane */
    //@{
        virtual const std::wstring& GetTitle() const;
        virtual DisplayMode GetDisplayMode() const;
        virtual HWND GetPaneHWND() const;
        virtual bool IsResizeable() const;
        virtual void PrePaneSelection();
    //@}

BEGIN_MSG_MAP(CSettingsDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
    MESSAGE_HANDLER(SWP_SET_DIALOG, OnSetDialog)
    MESSAGE_HANDLER(SWP_CHANGES_APPLIED, OnChangesApplied)
    MESSAGE_HANDLER(SWP_CHANGES_RESET, OnChangesReset)
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_HANDLER(IDC_PASSWORD, EN_CHANGE, OnChangePassword)
	COMMAND_HANDLER(IDC_REMEMBERPASSWORD, BN_CLICKED, OnClickedRememberpassword)
	COMMAND_HANDLER(IDC_BUFFERLENGTH, EN_CHANGE, OnChangeUsername)
    MESSAGE_HANDLER(WM_NOTIFYFORMAT, OnNotifyFormat)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

    LRESULT OnNotifyFormat(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSetDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChangesApplied(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChangesReset(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnChangePassword(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedRememberpassword(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
    LRESULT OnChangeUsername(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

protected:
    SWRESULT SetData();

private:
    HWND m_hwndParent;
    HWND m_hwndPassword;
    HWND m_hwndRemember;
    HWND m_hwndUsername;
    BOOL m_fSettingsChanged;
    SWPluginServerStruct* m_pCurrentServer;
	BOOL m_fRememberPassUser;
    CString m_strPassword;
	CString m_strUsername;
};

#endif //__SETTINGSDLG_H_
