/*
    DFNetUtil.h
    Copyright (c) 2000-2004, Deep Fried Software. All rights reserved.
 */

#if !defined(AFX_NETUTIL_H__EFB90F60_9FD9_11D5_9614_0040333C2E7E__INCLUDED_)
#define AFX_NETUTIL_H__EFB90F60_9FD9_11D5_9614_0040333C2E7E__INCLUDED_

#ifdef SWSERVICES_EXPORTS
#define SWSERVICES_API __declspec(dllexport)
#else
#define SWSERVICES_API __declspec(dllimport)
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

enum SWRESULT;

/**
 * @brief Provides a set of helper functions to simplify the network coding process.
 */
class SWSERVICES_API DFNetUtil  
{
    #pragma warning( push )
	#pragma warning( disable : 4251 )

public:
	DFNetUtil();
	virtual ~DFNetUtil();

    /**
     * Retrieves the proper address for the IN_ADDR structure (ULONG) from
     * either an IPv4 address or Domain Name.
     *
     * @return SWResult defining the success of the function
     * @retval SW_OK values In lServer are usable
     * @retval SW_FAIL String was not valid, call WSAGetLastError for more info
     */
	static SWRESULT getServerFromString( LPCTSTR strAddr, ULONG &lServer );

    /**
     * Retrieves a human readable description of the passed in WinSock error
     * and returns it in strMsg
     *
     * @return SWResult defining the success of the function
     * @retval SW_OK The value was found in this function
     * @retval SW_Fail The value could not be found and strMsg = "Uknown Error Occured"
     */
	static SWRESULT getStringFromWinsockError( int iErr, CAtlString &strMsg );

	#pragma warning( pop )
};

#endif // !defined(AFX_NETUTIL_H__EFB90F60_9FD9_11D5_9614_0040333C2E7E__INCLUDED_)
