/*
    IObserver.h
    Copyright (c) 2000-2004, Deep Fried Software. All rights reserved.
 */

#if !defined(AFX_IOBSERVER_H__7F7EC620_EA7B_11D6_961A_00036D14969D__INCLUDED_)
#define AFX_ASPECT_H__7F7EC620_EA7B_11D6_961A_00036D14969D__INCLUDED

#ifdef SWSERVICES_EXPORTS
#define SWSERVICES_API __declspec(dllexport)
#else
#define SWSERVICES_API __declspec(dllimport)
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Subject;
class Aspect;

/**
 *  Observer pattern.
 *  <br><br>See Also: 
 *  \ref Subject
 */
 
class SWSERVICES_API IObserver  
{
public:
        /**
         *  When implemented, this function will be called to notify the object
         *  that a registered event has been triggered.
         */
	virtual void Notification(Subject* subject, const Aspect& aspect) =0;
};

#endif // !defined(AFX_ASPECT_H__7F7EC620_EA7B_11D6_961A_00036D14969D__INCLUDED_)
