/*
    Subject.h
    Copyright (c) 2000-2004, Deep Fried Software. All rights reserved.
 */

#if !defined(AFX_SUBJECT_H__74667FC0_EA86_11D6_961A_00036D14969D__INCLUDED_)
#define AFX_SUBJECT_H__74667FC0_EA86_11D6_961A_00036D14969D__INCLUDED_

#ifdef SWSERVICES_EXPORTS
#define SWSERVICES_API __declspec(dllexport)
#else
#define SWSERVICES_API __declspec(dllimport)
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Aspect.h"

class IObserver;

/**
 *  blah
 *  <br><br>
 *  discuss threaded usage
 *  <br><br>See Also: 
 *  \ref IObserver
 */

class SWSERVICES_API Subject  
{
public:
	static Aspect RECEIVE_ALL;

	Subject();
	virtual ~Subject();

        /**
         *  description
         *  <br><br>
         *  Registering the RECIEVE_ALL aspect will register the observer for all
         *  notifications from this object.
         *
         *  \param observer The object to receive the notification
         *  \param aspect   The object that represents a notification type
         *
         *  \pre  The observer should not have be registered for the aspect.
         *  \post The observer is registered for the aspect.
         */
	void Register(IObserver* observer, const Aspect& aspect);
        /**
         *  description
         *  <br><br>
         *  Unregistering the RECIEVE_ALL aspect will unregister the observer from all
         *  notifications from this object.
         *
         *  \param observer The object will no longer receive the notification
         *  \param aspect   The object that represents a notification type
         *
         *  \pre The observer should be registered for the aspect.
         *  \post The observer is no longer registered for the aspect.
         */
	void Unregister(IObserver* observer, const Aspect& aspect);

	void Publish(Subject* subject, const Aspect& aspect);

private:
	class Impl;
	Impl *pImpl;
};

#endif // !defined(AFX_SUBJECT_H__74667FC0_EA86_11D6_961A_00036D14969D__INCLUDED_)
